HAT-TRAIL(1)

NAME
hat-trail - find a bug by algorithmic debugging

SYNOPSIS
hat-trail [prog[.hat]]

DESCRIPTION
hat-trail is an interactive tool for exploring the trace of a given Haskell program prog supplied as its argument. Exploration proceeds backwards, starting at the program output or an error message (with which the computation aborted), finding at each step the direct parent expression of the selected item. This is particularly useful for locating an error. You start at the observed faulty behaviour and work backwards towards the source of the error.

Every reduction replaces an instance of the left-hand side of a program equation by an instance of its right-hand side. The instance of the left-hand side ``creates'' the instance of the right-hand side and is therefore called its parent. With hat-trail you can obtain the parent of any expression or sub-expression already visible.

FILES

/usr/local/bin/hat-trail

SEE ALSO
nhc98(1), hat-stack(1), hat-observe(1), hat-detect(1)